/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2DFmode))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern8 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern8 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern8 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern8 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern8 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern8 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern8 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern8 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern8 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern8 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern8 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern8 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern8 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern8 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern8 (x1, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern8 (x1, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !s390_comparison (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !s390_comparison (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern19 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V2DFmode:
      if (pattern19 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 1;

    case E_V1TFmode:
      if (pattern19 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 2;

    case E_TFmode:
      if (pattern19 (x1, 
E_TFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i1
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 33
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x4, 0);
  operands[0] = x12;
  x13 = XEXP (x3, 0);
  switch (GET_CODE (x13))
    {
    case GT:
    case LE:
      operands[5] = x13;
      if (!s390_brx_operator (operands[5], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      x16 = XEXP (x13, 1);
      if (GET_CODE (x16) != SUBREG)
        return -1;
      x17 = XEXP (x8, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x18 = XEXP (x14, 0);
      operands[1] = x18;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      x20 = XEXP (x7, 0);
      operands[3] = x20;
      x21 = XEXP (x9, 0);
      operands[4] = x21;
      x22 = XEXP (x16, 0);
      if (!rtx_equal_p (x22, operands[2]))
        return -1;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XEXP (x17, 0);
      if (!rtx_equal_p (x24, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x15))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x17), 0))
            return -1;
          switch (SUBREG_BYTE (x16))
            {
            case 8:
              return pattern76 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

            case 4:
              if (pattern76 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x15) != E_SImode
              || maybe_ne (SUBREG_BYTE (x16), 12)
              || GET_MODE (x16) != E_SImode
              || maybe_ne (SUBREG_BYTE (x17), 4)
              || GET_MODE (x17) != E_SImode
              || GET_MODE (x14) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x8) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case NE:
      x16 = XEXP (x13, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x17 = XEXP (x8, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      x20 = XEXP (x7, 0);
      operands[2] = x20;
      x21 = XEXP (x9, 0);
      operands[3] = x21;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern77 (x8, 
E_SImode) != 0)
            return -1;
          return 3;

        case E_DImode:
          if (pattern77 (x8, 
E_DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  return 0;
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x8, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          return pattern145 (x8, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern145 (x8, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CLOBBER:
      res = pattern146 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !nonimmediate_operand (operands[1], E_V1TImode))
        return -1;
      return 5;

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !nonimmediate_operand (operands[1], E_V1TFmode))
        return -1;
      return 6;

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !nonimmediate_operand (operands[1], E_TImode))
        return -1;
      return 7;

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !nonimmediate_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonmemory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[4]))
    {
    case E_DImode:
      if (!scratch_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern221 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !loc_operand (operands[3], i1)
      || !loc_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern282 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern300 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 13);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1185; /* vec_widen_umult_even_v1qi */

    case 1:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1186; /* vec_widen_umult_even_v2qi */

    case 2:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1187; /* vec_widen_umult_even_v4qi */

    case 3:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1188; /* vec_widen_umult_even_v8qi */

    case 4:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1189; /* vec_widen_umult_even_v16qi */

    case 5:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1190; /* vec_widen_umult_even_v1hi */

    case 6:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1191; /* vec_widen_umult_even_v2hi */

    case 7:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1192; /* vec_widen_umult_even_v4hi */

    case 8:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1193; /* vec_widen_umult_even_v8hi */

    case 9:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1194; /* vec_widen_umult_even_v1si */

    case 10:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1195; /* vec_widen_umult_even_v2si */

    case 11:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1196; /* vec_widen_umult_even_v4si */

    case 12:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1197; /* vec_widen_umult_even_v1di */

    case 13:
      if (!(
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1198; /* vec_widen_umult_even_v2di */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 63:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_mask_operand (operands[2], E_QImode)
          || !
#line 201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[2]) < 7))
        return -1;
      return 16; /* vlbb */

    case 65:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 227 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 17; /* *vlrlrv16qi */

    case 66:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 18; /* vec_packv8hi */

        case 1:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 19; /* vec_packv4si */

        case 2:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 20; /* vec_packv2di */

        default:
          return -1;
        }

    case 67:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 21; /* vec_packsv8hi */

        case 1:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 22; /* vec_packsv4si */

        case 2:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 23; /* vec_packsv2di */

        default:
          return -1;
        }

    case 70:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 27; /* vec_packsuv8hi */

        case 1:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 28; /* vec_packsuv4si */

        case 2:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 29; /* vec_packsuv2di */

        default:
          return -1;
        }

    case 75:
      return recog_2 (x1, insn, pnum_clobbers);

    case 76:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 593 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 92; /* *vstrlrv16qi */

    case 77:
      if (pattern18 (x1, 
E_V16QImode, 
E_V2DImode) != 0
          || !
#line 609 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 93; /* vbpermv16qi */

    case 82:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 110; /* vaccb_v16qi */

        case 1:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 111; /* vacch_v8hi */

        case 2:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 112; /* vaccf_v4si */

        case 3:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 113; /* vaccg_v2di */

        case 4:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 114; /* vaccq_v1ti */

        case 5:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 115; /* vaccq_ti */

        default:
          return -1;
        }

    case 85:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 127; /* vec_avgv16qi */

        case 1:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 128; /* vec_avgv8hi */

        case 2:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 129; /* vec_avgv4si */

        case 3:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 130; /* vec_avgv2di */

        case 4:
          if (!(
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 131; /* vec_avgv1ti */

        case 5:
          if (!(
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 132; /* vec_avgti */

        default:
          return -1;
        }

    case 86:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 133; /* vec_avguv16qi */

        case 1:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 134; /* vec_avguv8hi */

        case 2:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 135; /* vec_avguv4si */

        case 3:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 136; /* vec_avguv2di */

        case 4:
          if (!(
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 137; /* vec_avguv1ti */

        case 5:
          if (!(
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 138; /* vec_avguti */

        default:
          return -1;
        }

    case 87:
      if (pattern21 (x1, 
E_V4SImode) != 0
          || !
#line 741 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 139; /* vec_checksum */

    case 88:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x2, 
E_V16QImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 140; /* vec_gfmsumv16qi */

        case E_V8HImode:
          if (pattern19 (x2, 
E_V8HImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 141; /* vec_gfmsumv8hi */

        case E_V4SImode:
          if (pattern19 (x2, 
E_V4SImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 142; /* vec_gfmsumv4si */

        default:
          return -1;
        }

    case 89:
      if (pattern18 (x1, 
E_V2DImode, 
E_V16QImode) != 0
          || !
#line 859 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 143; /* vec_gfmsum_128 */

    case 47:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 182; /* vec_smulhv16qi */

        case 1:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 183; /* vec_smulhv8hi */

        case 2:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 184; /* vec_smulhv4si */

        case 3:
          if (!(
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 185; /* vec_smulhv2di */

        case 4:
          if (!(
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 186; /* vec_smulhv1ti */

        case 5:
          if (!(
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 187; /* vec_smulhti */

        default:
          return -1;
        }

    case 48:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 188; /* vec_umulhv16qi */

        case 1:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 189; /* vec_umulhv8hi */

        case 2:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 190; /* vec_umulhv4si */

        case 3:
          if (!(
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 191; /* vec_umulhv2di */

        case 4:
          if (!(
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 192; /* vec_umulhv1ti */

        case 5:
          if (!(
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 193; /* vec_umulhti */

        default:
          return -1;
        }

    case 97:
      return recog_6 (x1, insn, pnum_clobbers);

    case 102:
      return recog_5 (x1, insn, pnum_clobbers);

    case 103:
      switch (pattern24 (x1))
        {
        case 0:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 297; /* vec_srabv16qi */

        case 1:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 298; /* vec_srabv8hi */

        case 2:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 299; /* vec_srabv4si */

        case 3:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 300; /* vec_srabv2di */

        case 4:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 301; /* vec_srabv1ti */

        case 5:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 302; /* vec_srabti */

        case 6:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 303; /* vec_srabv4sf */

        case 7:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 304; /* vec_srabv2df */

        case 8:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 305; /* vec_srabv1tf */

        case 9:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 306; /* vec_srabtf */

        default:
          return -1;
        }

    case 104:
      return recog_4 (x1, insn, pnum_clobbers);

    case 106:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 337; /* vscbib_v16qi */

        case 1:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 338; /* vscbih_v8hi */

        case 2:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 339; /* vscbif_v4si */

        case 3:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 340; /* vscbig_v2di */

        case 4:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 341; /* vscbiq_v1ti */

        case 5:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 342; /* vscbiq_ti */

        default:
          return -1;
        }

    case 94:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1215 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 345; /* vec_sum_u128v4si */

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !
#line 1215 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 346; /* vec_sum_u128v2di */

        default:
          return -1;
        }

    case 109:
      return recog_3 (x1, insn, pnum_clobbers);

    case 130:
      return recog_12 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern26 (x1, 
3, 
2, 
1, 
0) != 0
          || !
#line 2224 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 501; /* vclfnhs_v8hi */

    case 139:
      if (pattern26 (x1, 
7, 
6, 
5, 
4) != 0
          || !
#line 2235 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 502; /* vclfnls_v8hi */

    case 141:
      if (pattern27 (x1) != 0
          || !
#line 2254 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 504; /* vcfn_v8hi */

    case 142:
      if (pattern27 (x1) != 0
          || !
#line 2263 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 505; /* vcnf_v8hi */

    case 93:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1232 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 768; /* *vec_sum2v8hi */

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1232 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 769; /* *vec_sum2v4si */

        default:
          return -1;
        }

    case 95:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 770; /* *vec_sum4v16qi */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 771; /* *vec_sum4v8hi */

        default:
          return -1;
        }

    case 105:
      switch (pattern24 (x1))
        {
        case 0:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1087; /* *vec_srbv16qi */

        case 1:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1088; /* *vec_srbv8hi */

        case 2:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1089; /* *vec_srbv4si */

        case 3:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1090; /* *vec_srbv2di */

        case 4:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1091; /* *vec_srbv1ti */

        case 5:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1092; /* *vec_srbti */

        case 6:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1093; /* *vec_srbv4sf */

        case 7:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1094; /* *vec_srbv2df */

        case 8:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1095; /* *vec_srbv1tf */

        case 9:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1096; /* *vec_srbtf */

        default:
          return -1;
        }

    case 98:
      return recog_13 (x1, insn, pnum_clobbers);

    case 50:
      return recog_11 (x1, insn, pnum_clobbers);

    case 51:
      return recog_10 (x1, insn, pnum_clobbers);

    case 52:
      return recog_9 (x1, insn, pnum_clobbers);

    case 53:
      return recog_8 (x1, insn, pnum_clobbers);

    case 64:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 2427 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1406; /* vllv16qi */

    case 3:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 0
          || GET_MODE (x5) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 3734 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 1891; /* *mvcrl */

    case 36:
      return recog_7 (x1, insn, pnum_clobbers);

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 1917; /* *sethighpartsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          if (
#line 4260 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 1918; /* *sethighpartdi_64 */
            }
          if (!
#line 4270 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1919; /* *sethighpartdi_31 */

        default:
          return -1;
        }

    case 38:
      if (pattern21 (x1, 
E_DImode) != 0
          || !
#line 4946 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2006; /* bdepg */

    case 39:
      if (pattern21 (x1, 
E_DImode) != 0
          || !
#line 4959 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2007; /* bextg */

    case 29:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 11090 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2581; /* *tls_load_64 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 11100 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2582; /* *tls_load_31 */

        default:
          return -1;
        }

    case 34:
      if (pattern25 (x1, 
E_CCZmode) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2625; /* stack_protect_testdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2626; /* stack_protect_testsi */

        default:
          return -1;
        }

    case 2:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2627; /* stack_tiedi */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2628; /* stack_tiesi */

        default:
          return -1;
        }

    case 46:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!address_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode)
          || !
#line 12550 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
        return -1;
      *pnum_clobbers = 1;
      return 2660; /* lcbb */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[1] = x3;
  if (const_int_operand (operands[1], E_VOIDmode))
    {
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!const_int_operand (x5, E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 16L:
      x6 = XEXP (x2, 2);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x5;
      if (!
#line 4897 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (16, INTVAL (operands[1]), 64)
   && INTVAL (operands[1]) >= 0
   && INTVAL (operands[1]) < BITS_PER_WORD
   && INTVAL (operands[1]) % 16 == 0))
        return -1;
      return 2003; /* *insvdi_reg_imm */

    case 32L:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[1] = x5;
      switch (XWINT (x6, 0))
        {
        case 0L:
          if (!
#line 4921 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2004; /* *insv_h_di_reg_extimm */

        case 32L:
          if (!
#line 4932 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2005; /* *insv_l_di_reg_extimm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1502; /* zero_extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1504; /* zero_extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1506; /* zero_extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1508; /* zero_extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1510; /* zero_extendv4hiv4si2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5329 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2036; /* *zero_extendqihi2_64 */
          if (!
#line 5337 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2037; /* *zero_extendqihi2_31 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1513; /* vec_unpacku_hi_v16qi */

        case 1:
          if (!
#line 2705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1514; /* vec_unpacku_lo_v16qi */

        case 2:
          if (!
#line 2741 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1517; /* vec_unpacku_hi_v8hi */

        case 3:
          if (!
#line 2751 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1518; /* vec_unpacku_lo_v8hi */

        case 4:
          if (!
#line 2787 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1521; /* vec_unpacku_hi_v4si */

        case 5:
          if (!
#line 2797 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1522; /* vec_unpacku_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case GTU:
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_53 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_DImode)
          && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2298; /* *sconddi */
        }
      if (!s390_slb_comparison (operands[1], E_DImode)
          || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2300; /* *sconddi_neg */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_SImode))
        {
          *pnum_clobbers = 1;
          return 2299; /* *scondsi */
        }
      if (!s390_slb_comparison (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 2301; /* *scondsi_neg */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      return recog_22 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_23 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 816; /* iorv1qi3 */
          break;

        case 1:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 817; /* iorv2qi3 */
          break;

        case 2:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 818; /* iorv4qi3 */
          break;

        case 3:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 819; /* iorv8qi3 */
          break;

        case 4:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 820; /* iorv16qi3 */
          break;

        case 5:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 821; /* iorv1hi3 */
          break;

        case 6:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 822; /* iorv2hi3 */
          break;

        case 7:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 823; /* iorv4hi3 */
          break;

        case 8:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 824; /* iorv8hi3 */
          break;

        case 9:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 825; /* iorv1si3 */
          break;

        case 10:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 826; /* iorv2si3 */
          break;

        case 11:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 827; /* iorv4si3 */
          break;

        case 12:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 828; /* iorv1di3 */
          break;

        case 13:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 829; /* iorv2di3 */
          break;

        case 14:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 830; /* iorv1sf3 */
          break;

        case 15:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 831; /* iorv2sf3 */
          break;

        case 16:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 832; /* iorv4sf3 */
          break;

        case 17:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 833; /* iorv1df3 */
          break;

        case 18:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 834; /* iorv2df3 */
          break;

        case 19:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 835; /* iorv1tf3 */
          break;

        case 20:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 836; /* iorv1ti3 */
          break;

        case 21:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 837; /* iorti3 */
          break;

        case 22:
          if (
#line 8366 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2364; /* *iordi3 */
            }
          break;

        case 23:
          if (
#line 8503 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2369; /* *iorhi3_zarch */
            }
          if (
#line 8519 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2370; /* *iorhi3_esa */
            }
          break;

        case 24:
          if (
#line 8546 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2371; /* *iorqi3_zarch */
            }
          if (
#line 8564 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2372; /* *iorqi3_esa */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern131 (x3) == 0
          && 
#line 4788 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1996; /* *rosbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (
#line 8447 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        {
          *pnum_clobbers = 1;
          return 2367; /* *iorsi3_zarch */
        }
      if (!
#line 8475 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2368; /* *iorsi3_esa */

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1577; /* *vevalv1qi_iorior */

        case 1:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1586; /* *vevalv2qi_iorior */

        case 2:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1595; /* *vevalv4qi_iorior */

        case 3:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1604; /* *vevalv8qi_iorior */

        case 4:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1613; /* *vevalv16qi_iorior */

        case 5:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1622; /* *vevalv1hi_iorior */

        case 6:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1631; /* *vevalv2hi_iorior */

        case 7:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1640; /* *vevalv4hi_iorior */

        case 8:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1649; /* *vevalv8hi_iorior */

        case 9:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1658; /* *vevalv1si_iorior */

        case 10:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1667; /* *vevalv2si_iorior */

        case 11:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1676; /* *vevalv4si_iorior */

        case 12:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1685; /* *vevalv1di_iorior */

        case 13:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1694; /* *vevalv2di_iorior */

        case 14:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1703; /* *vevalv1ti_iorior */

        case 15:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1712; /* *vevalti_iorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1578; /* *vevalv1qi_iorxor */

        case 1:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1587; /* *vevalv2qi_iorxor */

        case 2:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1596; /* *vevalv4qi_iorxor */

        case 3:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1605; /* *vevalv8qi_iorxor */

        case 4:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1614; /* *vevalv16qi_iorxor */

        case 5:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1623; /* *vevalv1hi_iorxor */

        case 6:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1632; /* *vevalv2hi_iorxor */

        case 7:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1641; /* *vevalv4hi_iorxor */

        case 8:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1650; /* *vevalv8hi_iorxor */

        case 9:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1659; /* *vevalv1si_iorxor */

        case 10:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1668; /* *vevalv2si_iorxor */

        case 11:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1677; /* *vevalv4si_iorxor */

        case 12:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1686; /* *vevalv1di_iorxor */

        case 13:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1695; /* *vevalv2di_iorxor */

        case 14:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1704; /* *vevalv1ti_iorxor */

        case 15:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1713; /* *vevalti_iorxor */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern31 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4749 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1988; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4749 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 1990; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case MOD:
              if (pattern132 (x3, 
DIV) != 0
                  || pattern203 (x3) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[2] = x11;
                  if (!general_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (!rtx_equal_p (x12, operands[2])
                      || !
#line 7666 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2329; /* divmodtidi3 */

                case SIGN_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (GET_CODE (x12) != SIGN_EXTEND
                      || GET_MODE (x12) != E_DImode)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[2] = x13;
                  if (!nonimmediate_operand (operands[2], E_SImode))
                    return -1;
                  x14 = XEXP (x12, 0);
                  if (!rtx_equal_p (x14, operands[2])
                      || !
#line 7684 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2330; /* divmodtisi3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != TRUNCATE)
                return -1;
              x15 = XEXP (x8, 0);
              switch (GET_CODE (x15))
                {
                case UMOD:
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != ZERO_EXTEND)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != UDIV)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != ZERO_EXTEND)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2]))
                    return -1;
                  switch (XWINT (x7, 0))
                    {
                    case 64L:
                      if (pattern269 (x3, 
E_TImode, 
E_DImode) != 0
                          || !
#line 7745 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2331; /* udivmodtidi3 */

                    case 32L:
                      if (pattern269 (x3, 
E_DImode, 
E_SImode) != 0
                          || !
#line 7865 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                        return -1;
                      return 2333; /* udivmoddisi3 */

                    default:
                      return -1;
                    }

                case MOD:
                  if (GET_MODE (x15) != E_DImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != SIGN_EXTEND
                      || GET_MODE (x16) != E_DImode
                      || XWINT (x7, 0) != 32L)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != DIV
                      || GET_MODE (x10) != E_DImode)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != SIGN_EXTEND
                      || GET_MODE (x17) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode
                      || GET_MODE (x6) != E_DImode
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  if (!nonimmediate_operand (operands[2], E_SImode)
                      || GET_MODE (x5) != E_DImode
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2])
                      || !
#line 7804 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return -1;
                  return 2332; /* divmoddisi3 */

                default:
                  return -1;
                }

            case CLZ:
              if (pnum_clobbers == NULL
                  || pattern132 (x3, 
XOR) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != LSHIFTRT)
                return -1;
              x22 = XEXP (x12, 1);
              if (GET_CODE (x22) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x22), 4)
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XEXP (x22, 0);
              if (GET_CODE (x23) != CLZ
                  || GET_MODE (x23) != E_DImode
                  || pattern203 (x3) != 0)
                return -1;
              x14 = XEXP (x12, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x24 = XEXP (x23, 0);
              if (!rtx_equal_p (x24, operands[1])
                  || !
#line 9623 "../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2500; /* clztidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4768 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1992; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4768 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1994; /* *rosbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern167 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 496; /* *vec_extract_bswap_elemv8hi */

        case E_SImode:
          if (pattern167 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 497; /* *vec_extract_bswap_elemv4si */

        case E_SFmode:
          if (pattern167 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 498; /* *vec_extract_bswap_elemv4sf */

        case E_DImode:
          if (pattern167 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 499; /* *vec_extract_bswap_elemv2di */

        case E_DFmode:
          if (pattern167 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 500; /* *vec_extract_bswap_elemv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!memory_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 3350 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1568; /* *vstbrv8hi */

        case E_V4SImode:
          if (!memory_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 3350 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1569; /* *vstbrv4si */

        case E_V2DImode:
          if (!memory_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 3350 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1570; /* *vstbrv2di */

        case E_V1TImode:
          if (!memory_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !
#line 3350 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1571; /* *vstbrv1ti */

        case E_TImode:
          if (!memory_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !
#line 3350 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1572; /* *vstbrti */

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2631; /* bswapdi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 2632; /* bswapsi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2633; /* bswaphi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_CONCAT)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern168 (x3, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 599 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 619; /* *vec_vllezlfv4si */

        case E_V4SFmode:
          if (pattern168 (x3, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 599 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 620; /* *vec_vllezlfv4sf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern108 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 2416 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1404; /* *vec_load_pairv2di */

        case E_V2DFmode:
          if (pattern108 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 2416 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1405; /* *vec_load_pairv2df */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern33 (x3, 
TRUNCATE))
        {
        case 0:
          if (!
#line 2604 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1492; /* vec_pack_trunc_v8hi */

        case 1:
          if (!
#line 2604 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1493; /* vec_pack_trunc_v4si */

        case 2:
          if (!
#line 2604 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1494; /* vec_pack_trunc_v2di */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      switch (pattern33 (x3, 
SS_TRUNCATE))
        {
        case 0:
          if (!
#line 2616 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1495; /* vec_pack_ssat_v8hi */

        case 1:
          if (!
#line 2616 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1496; /* vec_pack_ssat_v4si */

        case 2:
          if (!
#line 2616 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1497; /* vec_pack_ssat_v2di */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern33 (x3, 
US_TRUNCATE))
        {
        case 0:
          if (!
#line 2628 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1498; /* vec_pack_usat_v8hi */

        case 1:
          if (!
#line 2628 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1499; /* vec_pack_usat_v4si */

        case 2:
          if (!
#line 2628 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1500; /* vec_pack_usat_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (pattern253 (x10, 
ZERO_EXTEND, 
PLUS) != 0)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x10, 0);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[1])
              || !
#line 6122 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 2192; /* *adddi3_zero_cc */

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!scratch_operand (operands[0], E_DImode)
              || !
#line 6135 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 2193; /* *adddi3_zero_cconly */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_81 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && scratch_operand (operands[0], E_DImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 6261 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2201; /* *adddi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 6301 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2205; /* *adddi3_carry2_cconly */
                }
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && scratch_operand (operands[0], E_SImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 6261 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2202; /* *addsi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 6301 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2206; /* *addsi3_carry2_cconly */
                }
              break;

            case E_TFmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_TFmode) == 0
                  && (
#line 6522 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2232; /* *addtf3_cconly */
              break;

            case E_FPRX2mode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_FPRX2mode) == 0
                  && (
#line 6522 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2233; /* *addfprx23_cconly */
              break;

            case E_DFmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_DFmode) == 0
                  && 
#line 6522 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 2234; /* *adddf3_cconly */
              break;

            case E_SFmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_SFmode) == 0
                  && 
#line 6522 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 2235; /* *addsf3_cconly */
              break;

            case E_TDmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_TDmode) == 0
                  && (
#line 6522 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 2236; /* *addtd3_cconly */
              break;

            case E_DDmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_DDmode) == 0
                  && (
#line 6522 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 2237; /* *adddd3_cconly */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x10) != E_DImode)
                return -1;
              if (general_operand (operands[2], E_DImode)
                  && (
#line 6319 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2207; /* *adddi3_cc */
              if (!const_int_operand (operands[2], E_DImode)
                  || !(
#line 6375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2213; /* *adddi3_imm_cc */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x10) != E_SImode)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6319 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return 2208; /* *addsi3_cc */
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 6375 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))))
                return -1;
              return 2214; /* *addsi3_imm_cc */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern146 (x1))
            {
            case 0:
              if (!(
#line 6341 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2209; /* *adddi3_cconly */

            case 1:
              if (!
#line 6341 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 2210; /* *addsi3_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x6, 0);
      if (GET_CODE (x15) != PLUS)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x17 = XEXP (x8, 0);
          operands[2] = x17;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern283 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6442 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2216; /* *addvdi3_ccoverflow */

            case E_DImode:
              if (pattern283 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6442 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 2217; /* *addvsi3_ccoverflow */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x8;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern284 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6465 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2218; /* *addvdi3_ccoverflow_const */

            case E_DImode:
              if (pattern284 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6465 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 2219; /* *addvsi3_ccoverflow_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_82 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern237 (x5, 
E_DImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 7037 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2282; /* *adddi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 7071 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2286; /* *adddi3_alc_carry2_cconly */
                }
              break;

            case E_SImode:
              if (pattern237 (x5, 
E_SImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 7037 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2283; /* *addsi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 7071 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2287; /* *addsi3_alc_carry2_cconly */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_CODE (x9) != SET
          || pattern213 (x9) != 0)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (pattern277 (x1, 
E_DImode) != 0
              || !(
#line 7087 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2288; /* *adddi3_alc_cc */

        case E_SImode:
          if (pattern277 (x1, 
E_SImode) != 0
              || !
#line 7087 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          return 2289; /* *addsi3_alc_cc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_108 (x1, insn, pnum_clobbers);

    case TRAP_IF:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != EQ)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !(
#line 9998 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2531; /* *load_and_trapdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !
#line 9998 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return -1;
          return 2532; /* *load_and_trapsi */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern14 (x1) != 0)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      x6 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x6, 1);
      operands[0] = x9;
      x12 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
          if (XWINT (x12, 0) != 0L)
            return -1;
          if (larl_operand (operands[1], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10439 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2546; /* indirect_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10439 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2547; /* indirect_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[2] = x12;
          if (register_operand (operands[2], E_DImode)
              && larl_operand (operands[1], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10455 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2548; /* indirect_jump_via_inlinethunkdi */
          if (!register_operand (operands[2], E_SImode)
              || !larl_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10455 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2549; /* indirect_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (register_operand (operands[2], E_VOIDmode))
        {
          if (bras_sym_operand (operands[0], E_VOIDmode))
            {
              if (
#line 10865 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[2]) == Pmode))
                return 2567; /* *bras */
              if (
#line 10877 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[2]) == Pmode))
                return 2568; /* *brasl */
            }
          if (address_operand (operands[0], E_VOIDmode)
              && 
#line 10890 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[2]) == Pmode))
            return 2569; /* *basr */
        }
      if (register_operand (operands[2], E_DImode)
          && register_operand (operands[0], E_DImode))
        {
          if ((
#line 10913 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2570; /* *basr_via_thunkdi_z10 */
          if (pnum_clobbers != NULL
              && (
#line 10934 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2572; /* *basr_via_thunkdi */
            }
        }
      if (!register_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      if ((
#line 10913 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2571; /* *basr_via_thunksi_z10 */
      if (pnum_clobbers == NULL
          || !(
#line 10934 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2573; /* *basr_via_thunksi */

    case RETURN:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != USE)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          if ((
#line 11844 "../../gcc/config/s390/s390.md"
(TARGET_CPU_Z10 || !TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2619; /* *returndi */
          if (pnum_clobbers == NULL
              || !(
#line 11872 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 2621; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          if ((
#line 11844 "../../gcc/config/s390/s390.md"
(TARGET_CPU_Z10 || !TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return 2620; /* *returnsi */
          if (pnum_clobbers == NULL
              || !(
#line 11872 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 2622; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (load_multiple_operation (operands[0], E_VOIDmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && s_operand (operands[2], E_DImode)
                  && 
#line 3242 "../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
                return 1874; /* *load_multiple_di */
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && s_operand (operands[2], E_SImode)
                  && 
#line 3255 "../../gcc/config/s390/s390.md"
(reload_completed))
                return 1875; /* *load_multiple_si */
              break;

            default:
              break;
            }
        }
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!s_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !
#line 3334 "../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
            return -1;
          return 1876; /* *store_multiple_di */

        case E_SImode:
          if (!s_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 3348 "../../gcc/config/s390/s390.md"
(reload_completed))
            return -1;
          return 1877; /* *store_multiple_si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 18
          || !execute_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 2);
      operands[3] = x7;
      if (larl_operand (operands[3], E_SImode)
          && 
#line 3367 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return 1878; /* *execute_rl */
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 3379 "../../gcc/config/s390/s390.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return -1;
      return 1879; /* *execute */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern101 (x2))
    {
    case 0:
      if (all_ones_operand (operands[1], E_V1QImode)
          && const0_operand (operands[2], E_V1QImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_94 (insn, operands);
      if (!const0_operand (operands[1], E_V1QImode)
          || !all_ones_operand (operands[2], E_V1QImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_113 (insn, operands);

    case 1:
      if (all_ones_operand (operands[1], E_V2QImode)
          && const0_operand (operands[2], E_V2QImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_95 (insn, operands);
      if (!const0_operand (operands[1], E_V2QImode)
          || !all_ones_operand (operands[2], E_V2QImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_114 (insn, operands);

    case 2:
      if (all_ones_operand (operands[1], E_V4QImode)
          && const0_operand (operands[2], E_V4QImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_96 (insn, operands);
      if (!const0_operand (operands[1], E_V4QImode)
          || !all_ones_operand (operands[2], E_V4QImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_115 (insn, operands);

    case 3:
      if (all_ones_operand (operands[1], E_V8QImode)
          && const0_operand (operands[2], E_V8QImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_97 (insn, operands);
      if (!const0_operand (operands[1], E_V8QImode)
          || !all_ones_operand (operands[2], E_V8QImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_116 (insn, operands);

    case 4:
      if (all_ones_operand (operands[1], E_V16QImode)
          && const0_operand (operands[2], E_V16QImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_98 (insn, operands);
      if (!const0_operand (operands[1], E_V16QImode)
          || !all_ones_operand (operands[2], E_V16QImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_117 (insn, operands);

    case 5:
      if (all_ones_operand (operands[1], E_V1HImode)
          && const0_operand (operands[2], E_V1HImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_99 (insn, operands);
      if (!const0_operand (operands[1], E_V1HImode)
          || !all_ones_operand (operands[2], E_V1HImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_118 (insn, operands);

    case 6:
      if (all_ones_operand (operands[1], E_V2HImode)
          && const0_operand (operands[2], E_V2HImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_100 (insn, operands);
      if (!const0_operand (operands[1], E_V2HImode)
          || !all_ones_operand (operands[2], E_V2HImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_119 (insn, operands);

    case 7:
      if (all_ones_operand (operands[1], E_V4HImode)
          && const0_operand (operands[2], E_V4HImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_101 (insn, operands);
      if (!const0_operand (operands[1], E_V4HImode)
          || !all_ones_operand (operands[2], E_V4HImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_120 (insn, operands);

    case 8:
      if (all_ones_operand (operands[1], E_V8HImode)
          && const0_operand (operands[2], E_V8HImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_102 (insn, operands);
      if (!const0_operand (operands[1], E_V8HImode)
          || !all_ones_operand (operands[2], E_V8HImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_121 (insn, operands);

    case 9:
      if (all_ones_operand (operands[1], E_V1SImode)
          && const0_operand (operands[2], E_V1SImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_103 (insn, operands);
      if (!const0_operand (operands[1], E_V1SImode)
          || !all_ones_operand (operands[2], E_V1SImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_122 (insn, operands);

    case 10:
      if (all_ones_operand (operands[1], E_V2SImode)
          && const0_operand (operands[2], E_V2SImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_104 (insn, operands);
      if (!const0_operand (operands[1], E_V2SImode)
          || !all_ones_operand (operands[2], E_V2SImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_123 (insn, operands);

    case 11:
      if (all_ones_operand (operands[1], E_V4SImode)
          && const0_operand (operands[2], E_V4SImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_105 (insn, operands);
      if (!const0_operand (operands[1], E_V4SImode)
          || !all_ones_operand (operands[2], E_V4SImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_124 (insn, operands);

    case 12:
      if (all_ones_operand (operands[1], E_V1DImode)
          && const0_operand (operands[2], E_V1DImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_106 (insn, operands);
      if (!const0_operand (operands[1], E_V1DImode)
          || !all_ones_operand (operands[2], E_V1DImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_125 (insn, operands);

    case 13:
      if (all_ones_operand (operands[1], E_V2DImode)
          && const0_operand (operands[2], E_V2DImode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_107 (insn, operands);
      if (!const0_operand (operands[1], E_V2DImode)
          || !all_ones_operand (operands[2], E_V2DImode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_126 (insn, operands);

    case 14:
      if (all_ones_operand (operands[1], E_V1SFmode)
          && const0_operand (operands[2], E_V1SFmode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_108 (insn, operands);
      if (!const0_operand (operands[1], E_V1SFmode)
          || !all_ones_operand (operands[2], E_V1SFmode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_127 (insn, operands);

    case 15:
      if (all_ones_operand (operands[1], E_V2SFmode)
          && const0_operand (operands[2], E_V2SFmode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_109 (insn, operands);
      if (!const0_operand (operands[1], E_V2SFmode)
          || !all_ones_operand (operands[2], E_V2SFmode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_128 (insn, operands);

    case 16:
      if (all_ones_operand (operands[1], E_V4SFmode)
          && const0_operand (operands[2], E_V4SFmode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_110 (insn, operands);
      if (!const0_operand (operands[1], E_V4SFmode)
          || !all_ones_operand (operands[2], E_V4SFmode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_129 (insn, operands);

    case 17:
      if (all_ones_operand (operands[1], E_V1DFmode)
          && const0_operand (operands[2], E_V1DFmode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_111 (insn, operands);
      if (!const0_operand (operands[1], E_V1DFmode)
          || !all_ones_operand (operands[2], E_V1DFmode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_130 (insn, operands);

    case 18:
      if (all_ones_operand (operands[1], E_V2DFmode)
          && const0_operand (operands[2], E_V2DFmode)
          && 
#line 2526 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_112 (insn, operands);
      if (!const0_operand (operands[1], E_V2DFmode)
          || !all_ones_operand (operands[2], E_V2DFmode)
          || !
#line 2540 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_131 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (nonimmediate_operand (operands[0], E_TFmode))
        {
          if (GET_CODE (x2) == SUBREG
              && known_eq (SUBREG_BYTE (x2), 0)
              && GET_MODE (x2) == E_TFmode)
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (general_operand (operands[1], E_FPRX2mode)
                  && 
#line 682 "../../gcc/config/s390/vector.md"
(!(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))))
                return gen_split_37 (insn, operands);
            }
          operands[1] = x2;
          if (general_operand (operands[1], E_TFmode))
            {
              if ((
#line 2825 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_299 (insn, operands);
              if ((
#line 2841 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_302 (insn, operands);
            }
        }
      operands[1] = x2;
      if (memory_operand (operands[1], E_TFmode)
          && register_operand (operands[0], E_TFmode))
        {
          if ((
#line 2857 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return gen_split_305 (insn, operands);
          if ((
#line 2873 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return gen_split_308 (insn, operands);
        }
      if (!register_operand (operands[1], E_TFmode)
          || !memory_operand (operands[0], E_TFmode)
          || !(
#line 2889 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return NULL;
      return gen_split_311 (insn, operands);

    case VEC_DUPLICATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 713 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_38 (insn, operands);

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 713 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_39 (insn, operands);

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 713 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_40 (insn, operands);

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 713 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_41 (insn, operands);

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 713 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_42 (insn, operands);

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 713 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_43 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      if (pattern7 (x1) != 0
          || !(
#line 2024 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 2026 "../../gcc/config/s390/vector.md"
( 1)))
        return NULL;
      return gen_split_48 (insn, operands);

    case SMIN:
      if (pattern7 (x1) != 0
          || !(
#line 2060 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 2062 "../../gcc/config/s390/vector.md"
( 1)))
        return NULL;
      return gen_split_49 (insn, operands);

    case IF_THEN_ELSE:
      return split_3 (x1, insn);

    case AND:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_141 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_150 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_159 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_168 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_177 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_186 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_204 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_213 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_222 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_231 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_240 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_249 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_258 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_267 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_276 (insn, operands);

        case 16:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_142 (insn, operands);

        case 17:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_151 (insn, operands);

        case 18:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_160 (insn, operands);

        case 19:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_169 (insn, operands);

        case 20:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_178 (insn, operands);

        case 21:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_187 (insn, operands);

        case 22:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 23:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_205 (insn, operands);

        case 24:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_214 (insn, operands);

        case 25:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_223 (insn, operands);

        case 26:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_232 (insn, operands);

        case 27:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_241 (insn, operands);

        case 28:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_250 (insn, operands);

        case 29:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_259 (insn, operands);

        case 30:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_268 (insn, operands);

        case 31:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_277 (insn, operands);

        case 32:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 33:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_152 (insn, operands);

        case 34:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_161 (insn, operands);

        case 35:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_170 (insn, operands);

        case 36:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_179 (insn, operands);

        case 37:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_188 (insn, operands);

        case 38:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 39:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_206 (insn, operands);

        case 40:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_215 (insn, operands);

        case 41:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_224 (insn, operands);

        case 42:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_233 (insn, operands);

        case 43:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_242 (insn, operands);

        case 44:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_251 (insn, operands);

        case 45:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_260 (insn, operands);

        case 46:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_269 (insn, operands);

        case 47:
          if (!(
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_278 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      return split_4 (x1, insn);

    case XOR:
      return split_5 (x1, insn);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 33)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_VOIDmode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (!memory_operand (operands[1], E_VOIDmode)
          || !
#line 1505 "../../gcc/config/s390/s390.md"
(reload_completed
   && s390_match_ccmode (insn, CCUmode)
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
        return NULL;
      return gen_split_285 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XVECEXP (x2, 0, 0);
      operands[1] = x6;
      switch (XINT (x2, 1))
        {
        case 30:
          switch (pattern80 (x2))
            {
            case 0:
              if (!
#line 2167 "../../gcc/config/s390/s390.md"
( reload_completed))
                return NULL;
              return gen_split_290 (insn, operands);

            case 1:
              if (!(
#line 2174 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 2176 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return NULL;
              return gen_split_291 (insn, operands);

            default:
              return NULL;
            }

        case 5:
          if (GET_MODE (x2) != E_SImode
              || !nonimmediate_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_VOIDmode)
              || !
#line 3788 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_325 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_QImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !(
#line 5305 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5307 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_352 (insn, operands);

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !(
#line 5337 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5339 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_353 (insn, operands);

        default:
          return NULL;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (x2))
        {
        case EQ:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2130 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_50 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2130 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_51 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case GT:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2150 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2152 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_52 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2150 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2152 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_53 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case GTU:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2184 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2186 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_54 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2184 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2186 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_55 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      switch (pattern45 (x2))
        {
        case 0:
          if (!(
#line 7285 "../../gcc/config/s390/s390.md"
(reload_completed) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_363 (insn, operands);

        case 1:
          if (!
#line 7285 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_364 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 795 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return NULL;
          return gen_split_375 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return NULL;
          return gen_split_376 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return NULL;
          return gen_split_377 (insn, operands);

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_HImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return NULL;
      return gen_split_392 (insn, operands);

    default:
      return NULL;
    }
}
